class FlipClockBlackApplet : Applet
{
    Image imgBG, imgH1, imgH2, imgM1, imgM2, imgCol, imgAMPM, imgAlarm, imgAlarmDisable, imgSignal, imgBattery, imgBatteryC;
    int x, y, r, w, h, width1, isPressed, currentHours, currentHours2, signal;
    string h1, h2, m1, m2, ampm, h1224, provider, acline;

    Label lblAlarm, lblBattery, lblOperator, lblCharging;

    bool IsNoServ, IsRadioOff, IsSearching;

    RegistryNotification time;
    RegistryNotification alarm1;
    RegistryNotification alarm1Flag;
    RegistryNotification alarm2;
    RegistryNotification alarm2Flag;
    RegistryNotification alarm3;
    RegistryNotification alarm3Flag;
    RegistryKey op;

    DateTime dt;

    DataTable appts;

    Timer clickTimer;
    Timer bgTimer;
    
    void Load()
    {

        SetTitleMode("Date");

        imgBG.Surface.LoadFromFile("BG.jif");
        imgH1.Surface.LoadFromFile("0.jif");
        imgH2.Surface.LoadFromFile("0.jif");
        imgM1.Surface.LoadFromFile("0.jif");
        imgM2.Surface.LoadFromFile("0.jif");
        imgCol.Surface.LoadFromFile("s.jif");
        imgAMPM.Surface.LoadFromFile("am.jif");
        imgAlarm.Surface.LoadFromFile("Icon.Alarm.jif");
        imgAlarmDisable.Surface.LoadFromFile("Icon.Alarm.Disable.jif");
        imgBattery.Surface.LoadFromFile("Icon.Battery.jif");
        imgBatteryC.Surface.LoadFromFile("Icon.BatteryC.jif");
        imgSignal.Surface.LoadFromFile("sig0.jif");

        Controls.Add(imgBG);
        Controls.Add(imgH1);
        Controls.Add(imgH2);
        Controls.Add(imgM1);
        Controls.Add(imgM2);
        Controls.Add(imgCol);
        Controls.Add(imgAMPM);
        Controls.Add(imgAlarm);
        Controls.Add(imgAlarmDisable);
        Controls.Add(imgBattery);
        Controls.Add(imgBatteryC);
        Controls.Add(imgSignal);
        
        draw_images();

        time_OnNotify();					
        time.OnNotify = time_OnNotify;		
        time.Start("HKLM\\System\\State\\DateTime", "Time");

        clickTimer.OnTimer = clickTimer_OnTimer;
        bgTimer.OnTimer = bgTimer_OnTimer;

        imgBG.SetTabStop(true);
        imgH1.SetTabStop(true);
        imgH2.SetTabStop(true);
        imgM1.SetTabStop(true);
        imgM2.SetTabStop(true);
        imgCol.SetTabStop(true);
        imgAMPM.SetTabStop(true);
        imgAlarm.SetTabStop(true);
        imgAlarmDisable.SetTabStop(true);

        imgBG.OnClick = imgBG_OnClick;
        imgH1.OnClick = imgH1_OnClick;
        imgH2.OnClick = imgH2_OnClick;
        imgM1.OnClick = imgM1_OnClick;
        imgM2.OnClick = imgM2_OnClick;
        imgCol.OnClick = imgCol_OnClick;
        imgAMPM.OnClick = imgAMPM_OnClick;
        imgAlarm.OnClick = imgAlarm_OnClick;
        imgAlarmDisable.OnClick = imgAlarmDisable_OnClick;

        imgBG.OnClickHold = imgBG_OnClickHold;
        imgH1.OnClickHold = imgH1_OnClickHold;
        imgH2.OnClickHold = imgH2_OnClickHold;
        imgM1.OnClickHold = imgM1_OnClickHold;
        imgM2.OnClickHold = imgM2_OnClickHold;
        imgCol.OnClickHold = imgCol_OnClickHold;
        imgAMPM.OnClickHold = imgAMPM_OnClickHold;

        File.Read("Settings.txt", Attributes);
        h1224 = Attributes.Item("12or24h");   

    }

    void time_OnNotify()
    {
        File.Read("Settings.txt", Attributes);
        h1224 = Attributes.Item("12or24h");

        dt.Now();

        String s, t, filename;
        ampm = dt.ToString("tt");
        currentHours = dt.ToString("hh");
        currentHours2 = dt.ToString("h");

            if (currentHours2 < 1)
            {
                currentHours2 = "12";
                s = "12" + dt.ToString("mm");
            }
            else if (currentHours2 > 9)
            {

                s = dt.ToString("hmm");

            }
            else
            {

                s = "s" + dt.ToString("hmm");
            }
        
        if(h1224 == "24") 
        {
            s = dt.ToString("hhmm");
        }

        if (h1 != s.SubString(0, 1))
        {
            h1 = s.SubString(0, 1);
            filename = h1 + ".jif";
            imgH1.SetVisible(false);
            imgH1.Surface.LoadFromFile(filename);
            imgH1.SetVisible(true);
        }

        if (h2 != s.SubString(1, 1))
        {
            h2 = s.SubString(1, 1);
            filename = h2 + ".jif";
            imgH2.SetVisible(false);
            imgH2.Surface.LoadFromFile(filename);
            imgH2.SetVisible(true);
        }

        if (m1 != s.SubString(2, 1))
        {
            m1 = s.SubString(2, 1);
            filename = m1 + ".jif";
            imgM1.SetVisible(false);
            imgM1.Surface.LoadFromFile(filename);
            imgM1.SetVisible(true);
        }

        if (m2 != s.SubString(3, 1))
        {
            m2 = s.SubString(3, 1);
            filename = m2 + ".jif";
            imgM2.SetVisible(false);
            imgM2.Surface.LoadFromFile(filename);
            imgM2.SetVisible(true);
        }

        imgAMPM.SetVisible(false);
        imgAMPM.Surface.LoadFromFile(ampm + ".jif");
        if (h1224 == "12")
        {
            imgAMPM.SetVisible(true);
        }

        draw_images();

    }

    void draw_images()
    {
        x = 0;
        y = 0;
        w = GetWidth();
        h = GetHeight();

        int x1, y1, bgLeft, bgTop, colLeft, colLeft1, colLeft2, h2Left, h1Left, m1Left, m2Left, aLeft;
        
        bgLeft = (w - imgBG.GetWidth()) / 2;
        bgTop = (h - imgBG.GetHeight()) - 90;

        imgBG.SetBounds(bgLeft, bgTop);
        imgBG.SetVisible(true);

        colLeft = bgLeft + (imgBG.GetWidth() / 2) - (imgCol.GetWidth() / 2);
        colLeft1 = bgLeft + (imgBG.GetWidth() / 2) - (imgCol.GetWidth());
        y1 = bgTop + (imgBG.GetHeight() / 2) - (imgCol.GetHeight() / 2);

        imgCol.SetBounds(colLeft + isPressed, y1);

        colLeft2 = colLeft1;
        if (h1224 == "24")
        {
            colLeft2 = colLeft;
        }

        if (currentHours2 > 9)
        {
             colLeft2 = colLeft;
        }

        h2Left = colLeft2 - imgH2.GetWidth();
        y1 = bgTop + (imgBG.GetHeight() / 2) - (imgH2.GetHeight() / 2);

        imgH2.SetBounds(h2Left + isPressed, y1);

        h1Left = h2Left - imgH1.GetWidth();
        y1 = bgTop + (imgBG.GetHeight() / 2) - (imgH1.GetHeight() / 2);

        imgH1.SetBounds(h1Left + isPressed, y1);

        m1Left = colLeft + imgCol.GetWidth();
        y1 = bgTop + (imgBG.GetHeight() / 2) - (imgM1.GetHeight() / 2);

        imgM1.SetBounds(m1Left - isPressed, y1);

        m2Left = m1Left + imgM1.GetWidth();
        y1 = bgTop + (imgBG.GetHeight() / 2) - (imgM2.GetHeight() / 2);

        imgM2.SetBounds(m2Left - isPressed, y1);

        imgAMPM.SetBounds(colLeft + (isPressed * 2) - 180, y1 + 110);

        aLeft = colLeft + 160;

        imgSignal.SetBounds(24, 28);
        
        imgBattery.SetBounds(24, 232);
        imgBatteryC.SetBounds(24, 232);

        imgAlarm.SetBounds(424, 232);
        imgAlarmDisable.SetBounds(424, 232);   

        Controls.Add(lblOperator);   
        lblOperator.SetAlign("Right", "Center");
        lblOperator.SetFont("Font.Large");
        lblOperator.SetBounds(240, 28, 216, 40);  
        
        Controls.Add(lblBattery);
        lblBattery.SetAlign("Center", "Top");
        lblBattery.SetFont("Font.Medium");
        lblBattery.SetBounds(26, 232, 58, 40);

        Controls.Add(lblCharging);
        lblCharging.SetAlign("Left", "Top");
        lblCharging.SetFont("Font.Large");
        lblCharging.SetBounds(92, 232, 120, 40);
        lblCharging.SetText("Charging");

        Controls.Add(lblAlarm);
        lblAlarm.SetAlign("Right", "Top");
        lblAlarm.SetFont("Font.Large");
        lblAlarm.SetBounds(240, 232, 180, 40);

        isPressed = 0;

    }

    void imgAlarm_OnClick()
    {
        Process.Start("\\Windows\\Clock.exe");
    }
    void imgAlarmDisable_OnClick()
    {
        Process.Start("\\Windows\\Clock.exe");
    }
    void clock_Click()
    {
        clock_Pressed();
        draw_images();
        clickTimer.StartMillisecondsTimer(50);
    }
    void clock_Pressed()
    {
        isPressed = 10;
    }
    void clock_NotPressed()
    {
        imgBG.Surface.LoadFromFile("BG.jif");
        imgH1.Surface.LoadFromFile(h1 + ".jif");
        imgH2.Surface.LoadFromFile(h2 + ".jif");
        imgM1.Surface.LoadFromFile(m1 + ".jif");
        imgM2.Surface.LoadFromFile(m2 + ".jif");
        imgCol.Surface.LoadFromFile("s.jif");
        imgAMPM.Surface.LoadFromFile(ampm + ".jif");
        draw_images();
    }
    void imgH1_OnClick()
    {
        clock_Click();
    }
    void imgH2_OnClick()
    {
        clock_Click();
    }
    void imgM1_OnClick()
    {
        clock_Click();
    }
    void imgM2_OnClick()
    {
        clock_Click();
    }
    void imgCol_OnClick()
    {
        clock_Click();
    }
    void imgAMPM_OnClick()
    {
        clock_Click();
    }
    void imgBG_OnClick()
    {
        clock_Click();
    }

    void imgH1_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgH2_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgM1_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgM2_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgCol_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgAMPM_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }
    void imgBG_OnClickHold()
    {
        ScreenSettings s;
        FlowStack.Branch(s);
    }

    void signalMeter()
    {
	signal = Phone.GetSignalStrength();

	if (signal == 0)
	{                        
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig0.jif");
		imgSignal.SetVisible(true);        
	}
        
	if (signal > 0)
	{                        
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig25.jif");
		imgSignal.SetVisible(true);   
	}

	if (signal >= 25)
	{                        
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig50.jif");
		imgSignal.SetVisible(true);
	}

	if (signal >= 50)
	{                        
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig75.jif");
		imgSignal.SetVisible(true);
	}

	if (signal >= 75 )
	{                        
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig100.jif");
		imgSignal.SetVisible(true);
	}
    }

    void refreshBattery() 
    {
	BatteryStatus status;
	status.Refresh();
	string percent = status.GetPercent();
	acline = status.GetACLineStatus();

   	if (acline == "Offline")
	{
		imgBattery.SetVisible(true);
		imgBatteryC.SetVisible(false);
		lblBattery.SetText(percent + "%");
		lblCharging.SetVisible(false);
	}
	else if (acline == "Online")
	{
		imgBattery.SetVisible(false);
		imgBatteryC.SetVisible(true);
		lblBattery.SetText(percent + "%");
		lblCharging.SetVisible(true);
	}


    }

    void operator()
    {
	op.Open("HKLM\\System\\State\\Phone");
	op.GetValue("Current Operator Name", provider);    
	IsNoServ = Phone.GetIsNoService();
	IsRadioOff = Phone.GetIsRadioOff();
	IsSearching = Phone.GetIsSearchingForService();

	if (IsNoService)
	{
		lblOperator.SetText("No Service");
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig0.jif");
		imgSignal.SetVisible(true);  
	}
	else if (IsRadioOff)
	{
		lblOperator.SetText("Phone Off");
		imgSignal.SetVisible(false);
		imgSignal.Surface.LoadFromFile("sig0.jif");
		imgSignal.SetVisible(true);  
	}
	else if (IsSearching)
	{
		lblOperator.SetText("Searching...");
	}
	else
	{
		lblOperator.SetText(provider);
	}
    }

    void alarm_OnNotify()
    {
	ByteArray binFlag;
	ByteArray binTime;
  	int flag;
  	string hexTime;
	RegistryKey reg;
	int tmp;
	bool active = false;

	reg.Open("HKLM\\Software\\Microsoft\\Clock\\0");
	reg.GetValue("AlarmFlags", binFlag);
	flag = binFlag.GetByte(0);
	if (flag == 1)
	{
		reg.GetValue("AlarmTime", binTime);
		active = true;
	}
	else
	{
		reg.Open("HKLM\\Software\\Microsoft\\Clock\\1");
		reg.GetValue("AlarmFlags", binFlag);
		flag = binFlag.GetByte(0);
		if (flag == 1)
		{
			reg.GetValue("AlarmTime", binTime);
			active = true;
		}
		else
		{
			reg.Open("HKLM\\Software\\Microsoft\\Clock\\2");
			reg.GetValue("AlarmFlags", binFlag);
			flag = binFlag.GetByte(0);
			if (flag == 1)
			{
				reg.GetValue("AlarmTime", binTime);
				active = true;
			}
		}
	}
	
	if (active) 
	{
		string strAlarm = intToDate(binTime.GetWord(0));
		lblAlarm.SetText(strAlarm);
		lblAlarm.SetVisible(true);
		imgAlarm.SetVisible(true);
		imgAlarmDisable.SetVisible(false);
	}
	else
	{
		lblAlarm.SetVisible(true);
		lblAlarm.SetText("Alarm Off");
		imgAlarm.SetVisible(false);
		imgAlarmDisable.SetVisible(true);
	}
    }

    int hexToInt(string hex)
    {
  	int result = 0;
  	int n = hex.GetLength();
  	
  	int j, k;
  	int mult;
  	string aux1, aux2;
  	int cont = 0;
  	
  	int i = 0;
  	while (i < n) {
  		aux1 = hex.SubString(i, 2);
  		i += 2;
  		
  		j = 1;
  		while (j >= 0) {
	  		aux2 = aux1.SubString(j, 1);
	  		j--;
	  		
	  		mult = 1;
	  		k = 0;
	  		while (k < cont) {
	  			mult *= 16;
	  			k++;
	  		}
	
				result += mult * digitHexToInt(aux2);
	  		
	  		cont++;
	  	}
  	}
  	
  	return result;
    }
  
    int digitHexToInt(string hex) 
    {
  	int result = 0;
  	if (hex == "0") {
  		result = 0;
  	} else if (hex == "1") {
  		result = 1;
  	} else if (hex == "2") {
  		result = 2;
  	} else if (hex == "3") {
  		result = 3;
  	} else if (hex == "4") {
  		result = 4;
  	} else if (hex == "5") {
  		result = 5;
  	} else if (hex == "6") {
  		result = 6;
  	} else if (hex == "7") {
  		result = 7;
  	} else if (hex == "8") {
  		result = 8;
  	} else if (hex == "9") {
  		result = 9;
  	} else if (hex == "A") {
  		result = 10;
  	} else if (hex == "B") {
  		result = 11;
  	} else if (hex == "C") {
  		result = 12;
  	} else if (hex == "D") {
  		result = 13;
  	} else if (hex == "E") {
  		result = 14;
  	} else if (hex == "F") {
  		result = 15;
  	} else {
  		result = 0;
  	}
  	return result;
    }
  
    string intToDate(int minutes)
    {
  	int h = 0;
  	int m = minutes;
  	while (m >= 60) {
  		h++;
  		m -= 60;
  	}
  	
  	string result;
  	string tmp;
  	tmp = h;
  	if (h >= 10) {
  		result = tmp + ":";
  	} else {
  		result = "0" + tmp + ":";
  	}
  	tmp = m;
  	if (m >= 10) {
  		result += tmp;
  	} else {
  		result += "0" + tmp;
  	}
  	return result;
    }

    void clickTimer_OnTimer()
    {
        clock_NotPressed();
        Process.Start("\\Windows\\Clock.exe");
        clickTimer.Stop();
    }
 
   void bgTimer_OnTimer()
    {
        signalMeter();      
        refreshBattery();  
        operator();
    }

    void Activated()
    {
	time.Stop();
	time.Start("HKLM\\System\\State\\DateTime", "Time");
	time_OnNotify();
	alarm_OnNotify();
	bgTimer_OnTimer();
	bgTimer.StartSecondsTimer(10);   
    }
    void AppGotFocus()
    {
	time.Stop();
	time.Start("HKLM\\System\\State\\DateTime", "Time");
	time_OnNotify();
	alarm_OnNotify();
	bgTimer_OnTimer();
    }
    void AppLostFocus()
    {
	time.Stop();
	bgTimer.Stop();
    }
    void Deactivated()
    {
	time.Stop();
	bgTimer.Stop();
    }
}

class ScreenSettings : ListScreen
{
    Label lblTitle;

    String hourFormat;
    
    void Load()
    {
        Controls.Add(lblTitle);
        SetTitlePosition(lblTitle);
        lblTitle.SetText("Configure FlipClock Applet");

        AddItem("hours12_24", "Select 12h or 24h Format");
        
        OnListItemClick = OnListItemClick_Handler;
    }

    void OnListItemClick_Handler(ListItem li, int x, int y)
    {
        String id;
        id = li.Attributes.Item("ID");

                    if (id == "hours12_24")
                    { 
                        ScreenSelect1224 s;
                        FlowStack.Branch(s);
                    }
                    else if (id == "Alarm")
                    {
                       
                    }
                    else if (id == "Calendar")
                    {
                        
                    }
    }

    void ScreenSelect1224_OnDone(ListItem selectedItem)
    {
        
    }
    
}

class ScreenSelect1224 : ListScreen
{

    Label lblTitle;

    void Load()
    {
            Controls.Add(lblTitle);
            SetTitlePosition(lblTitle);
            lblTitle.SetText("Select 12h or 24h Format");
            SetSoftKeys("Back", "Cancel");

            AddItem("12h", "12 Hour Format");
            AddItem("24h", "24 Hour Format");

            OnListItemClick = OnListItemClick_Handler;
        
        
    }

    void OnListItemClick_Handler(ListItem selectedItem, int x, int y)
    {
        String id;
        id = selectedItem.Attributes.Item("ID");
        if (id == "12h")
        {
            Attributes.Add("12or24h", 12);
            File.Write("Settings.txt", Attributes);
            FlowStack.Return();
        }
        else if (id == "24h")
        {
            Attributes.Add("12or24h", 24);
            File.Write("Settings.txt", Attributes);
            FlowStack.Return();
        }
        OnDone(selectedItem);
        FlowStack.Return();
    }
}